unit ufrm_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Buttons, StdCtrls, ExtCtrls, ComCtrls, Mask, JvExMask,
  JvToolEdit, FileCtrl, JvDriveCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdFTP, JvExStdCtrls, JvCombobox, Contnrs,
  uServerInfo, IdFTPList;

type
  Tfrm_Main = class(TForm)
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    About1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Servers1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    lblHost: TLabel;
    Bevel1: TBevel;
    cmbHost: TComboBox;
    lblUser: TLabel;
    edtUser: TEdit;
    lblPassword: TLabel;
    edtPassword: TEdit;
    lblPort: TLabel;
    edtPort: TEdit;
    btnConnect: TSpeedButton;
    StatusBar1: TStatusBar;
    Splitter1: TSplitter;
    Panel4: TPanel;
    panel3: TPanel;
    Bevel2: TBevel;
    lblLocal: TLabel;
    Bevel3: TBevel;
    lblRemote: TLabel;
    JvFilesLocal: TJvFileListBox;
    JvFilesRemote: TJvFileListBox;
    IdFTP: TIdFTP;
    jvDriveCombo: TJvDriveCombo;
    SpeedButton1: TSpeedButton;
    lblLocalPath: TLabel;
    lblRemotePath: TLabel;
    popLocal: TPopupMenu;
    CreateDir1: TMenuItem;
    DeleteDir1: TMenuItem;
    DeleteFile1: TMenuItem;
    N2: TMenuItem;
    Send1: TMenuItem;
    RenameDir1: TMenuItem;
    N3: TMenuItem;
    PopupRemote: TPopupMenu;
    Send2: TMenuItem;
    N4: TMenuItem;
    CreateDir2: TMenuItem;
    DeleteDir2: TMenuItem;
    N5: TMenuItem;
    DeleteFile2: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Servers1Click(Sender: TObject);
    procedure JvFilesLocalDblClick(Sender: TObject);
    procedure jvDriveComboChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure IdFTPConnected(Sender: TObject);
    procedure IdFTPDisconnected(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure edtPortKeyPress(Sender: TObject; var Key: Char);
    procedure cmbHostChange(Sender: TObject);
    procedure CreateDir1Click(Sender: TObject);
    procedure DeleteDir1Click(Sender: TObject);
    procedure RenameDir1Click(Sender: TObject);
    procedure DeleteFile1Click(Sender: TObject);
    procedure JvFilesRemoteDblClick(Sender: TObject);
    procedure CreateDir2Click(Sender: TObject);
    procedure DeleteDir2Click(Sender: TObject);
    procedure DeleteFile2Click(Sender: TObject);
    procedure Send1Click(Sender: TObject);
    procedure Send2Click(Sender: TObject);

  private
    { Private declarations }
    ServerList : TObjectList;
    Connected : Boolean;

    procedure GetFtpItems;

    procedure RefreshServers;

    procedure SaveServerList;
    procedure LoadServerList;

    function HasMultipleSelections ( Sender : TObject ): boolean;
    function GetFirstSelectedItem ( Sender : TObject ) : integer;

    function GetPreviousPath ( Path : String ) : String;
  public
    { Public declarations }
  end;


  
  function ReadIntFromStream(Stream: TFileStream): Integer;
  function ReadBoolFromStream(Stream: TFileStream):Boolean;
  function ReadStrFromStream(Stream: TFileStream): string;
  function ReadFloatFromStream(Stream : TFileStream) : Single;


  procedure WriteIntToStream(Stream: TFileStream; Value: integer);
  procedure WriteBoolToStream(Stream: TFileStream; Value: Boolean);
  procedure WriteStrToStream(Stream: TFileStream; Value: string);
  procedure WriteFloatToStream(Stream : TFileStream; Value : single );

var
  frm_Main: Tfrm_Main;

implementation

uses ufrm_About, ufrm_Servers, ufrm_Directory;

{$R *.dfm}


//------------------------------------------------------------------------------

procedure WriteIntToStream(Stream: TFileStream; Value: integer);
var
  s: string;
begin
  s := inttostr(Value);
  while Length(s) < 4 do
    s := s + ' ';
  Stream.Write(Pchar(S)^, 4);
end; // WriteIntToStream

//------------------------------------------------------------------------------

procedure WriteBoolToStream( Stream : TFileStream; Value : Boolean);
var
  s: string;
begin
  s := intToStr(Integer(Value));
  while Length(s) < 4 do
    s := s + ' ';
  Stream.Write(PChar(S)^,4);
end; // WriteBoolToStream

//------------------------------------------------------------------------------

procedure WriteFloatToStream(Stream : TFileStream; Value : Single );
Var s : String;
begin
  s := FloatToStr ( Value );
  while Length ( s ) < 4 do
    s := s + ' ';
  Stream.Write( PChar ( S )^, 4 );
end;

//------------------------------------------------------------------------------

function ReadIntFromStream(Stream: TFileStream): Integer;
var tmpData: array[0..64] of Char;
begin
  FillChar(TmpData, 64, 0);
  Stream.Read(TmpData, 4);
  Result := StrToInt(Trim(StrPas(TmpData)));
end; // ReadIntFromStream
                          
//------------------------------------------------------------------------------

function ReadBoolFromStream(Stream:TFileStream):Boolean;
var TmpData: array[0..64] of Char;
begin
  FillChar(TmpData, 64, 0);
  Stream.Read(TmpData, 4 );
  Result := Boolean ( StrToInt ( Trim(StrPas(TmpData))));
end; // ReadBoolFromStream

//------------------------------------------------------------------------------

function ReadFloatFromStream(Stream : TFileStream) : Single;
var tmpData: Array[0..64] of Char;
begin
  FillChar( TmpData, 64, 0);
  Stream.Read( tmpData, 4 );
  Result := StrToFloat( StrPas(TmpData) );
end; // ReadFloatFromStream

//------------------------------------------------------------------------------

procedure WriteStrToStream(Stream: TFileStream; Value: string);
begin
  WriteIntToStream(Stream, Length(Value));
  Stream.Write(Pchar(Value)^, Length(Value));
end; // WriteStrToStream

//------------------------------------------------------------------------------

function ReadStrFromStream(Stream: TFileStream): string;
var TmpInt: Integer;
  TmpData: array[0..1024] of Char;
begin
  TmpInt := ReadIntFromStream(Stream);

  // Lezen van aantal timelines
  FillChar(TmpData, 1024, 0);
  Stream.Read(TmpData, TmpInt);
  Result := TmpData;
end; // ReadStrFromStream

//------------------------------------------------------------------------------

procedure WriteCharToStream(Stream: TFileStream; Value: Char);
begin
  Stream.Write(Value, 1);
end; // WriteCharToStream

//------------------------------------------------------------------------------

procedure Tfrm_Main.About1Click(Sender: TObject);
begin
  frm_About := Tfrm_About.Create ( Application );

  if frm_About.ShowModal = mrOk then begin
  end;

  frm_About.free;
end; // Tfrm_Main.About1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.Exit1Click(Sender: TObject);
begin
  close;
end; // Tfrm_Main.Exit1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.Servers1Click(Sender: TObject);
begin
  frm_Servers := TFrm_Servers.Create ( Application );
  
  with frm_Servers do begin
    Servers := ServerList;
    FillServerList;
  end;   

  if frm_Servers.ShowModal = mrOk then begin
    RefreshServers;
  end;

  frm_Servers.Free;
end; // Tfrm_Main.Servers1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.JvFilesLocalDblClick(Sender: TObject);
var SelectedItem : string;
    seperator : String;
    newPath : String;
begin
  if Not HasMultipleSelections( Sender ) then begin
    SelectedItem := TrimLeft ( JvFilesLocal.Items[GetFirstSelectedItem(Sender)] );

    seperator := JvFilesLocal.Directory[Length(JvFilesLocal.Directory)];
    if seperator <> '\' then
      newPath := JvFilesLocal.Directory + '\' + SelectedItem
    else
      newPath := JvFilesLocal.Directory + SelectedItem;

    if Not FileExists( newPath ) then
      JvFilesLocal.Directory := newPath + '\';
  end;
end; // Tfrm_Main.JvFilesLocalDblClick

//------------------------------------------------------------------------------

procedure Tfrm_Main.jvDriveComboChange(Sender: TObject);
begin
  try
    JvFilesLocal.Directory := jvDriveCombo.Drive + ':\';
  except
    ShowMessage ( 'No files found on ' + jvDriveCombo.Drive + ':\' );
  end;
end; // Tfrm_Main.jvDriveComboChange

//------------------------------------------------------------------------------

function Tfrm_Main.HasMultipleSelections ( Sender : TObject ): boolean;
var cnt : integer;
    ItemsSelected : integer;
begin
  Result := False;
  ItemsSelected := 0;

  if (Assigned ( Sender )) and (Sender.ClassType = TJvFileListBox) then begin
    for Cnt := 0 to TJvFileListBox ( Sender ).Items.Count -1 do begin

      if TJvFileListBox ( Sender ).Selected [cnt] then begin

        inc ( ItemsSelected );
        if ItemsSelected > 1 then begin
          Result := True;
          Break;
        end;
      end;
    end;
  end;
end; // Tfrm_Main.HasMultipleSelections

//------------------------------------------------------------------------------

function Tfrm_Main.GetFirstSelectedItem(Sender: TObject): integer;
var Cnt : integer;
begin
  result := -1;
  if ( Assigned ( Sender )) and ( Sender.ClassType = TJvFileListBox ) then begin
    for Cnt := 0 to TJvFileListBox ( Sender ).Items.Count -1 do begin
      if TJvFileListBox ( Sender ).Selected [ Cnt ] then begin
        Result := Cnt;
        Break;
      end;
    end;
  end;
end; // Tfrm_Main.GetFirstSelectedItem

//------------------------------------------------------------------------------

procedure Tfrm_Main.FormCreate(Sender: TObject);
begin
  panel3.DoubleBuffered := True;
  Panel4.DoubleBuffered := True;
  ServerList := TObjectList.Create;
  Connected := False;
  LoadServerList;
end; // Tfrm_Main.FormCreate

//------------------------------------------------------------------------------

procedure Tfrm_Main.SpeedButton1Click(Sender: TObject);
begin
  JvFilesLocal.Directory := GetPreviousPath ( JvFilesLocal.Directory );
end; // Tfrm_Main.SpeedButton1Click

//------------------------------------------------------------------------------

function Tfrm_Main.GetPreviousPath(Path: String): String;
var cnt    : integer;
    tmpStr : String;
begin
  tmpStr := Path;
  if Path[Length(Path)] = '\' then begin
    tmpStr := Copy ( Path, 0, Length(Path) -1 );
  end;

  for Cnt := Length ( Path ) downto 0 do begin
    if Path[cnt] = '\' then begin
      Result := Copy ( Path, 0, Cnt );
      Break;
    end;
  end;
end; // Tfrm_Main.GetPreviousPath

//------------------------------------------------------------------------------

procedure Tfrm_Main.btnConnectClick(Sender: TObject);
begin
  if Not Connected then begin
    if (cmbHost.Text <> '') and (edtUser.Text <> '') and
       (edtPassword.Text <> '') and (edtPort.Text <> '') then begin

      IdFTP.Host     := cmbHost.Text;
      IdFTP.Username := edtUser.Text;
      IdFTP.Password := edtPassword.Text;
      IdFTP.Port     := StrToInt ( edtPort.Text );
      IdFTP.Connect;

      GetFtpItems;
    end;
  end
  else
    IdFTP.Disconnect;
end; // Tfrm_Main.btnConnectClick

//------------------------------------------------------------------------------

procedure Tfrm_Main.IdFTPConnected(Sender: TObject);
begin
  Connected := True;
  StatusBar1.SimpleText := 'Connected to: ' + cmbHost.Text;

end; // Tfrm_Main.IdFTPConnected

//------------------------------------------------------------------------------

procedure Tfrm_Main.IdFTPDisconnected(Sender: TObject);
begin
  Connected := False;
  StatusBar1.SimpleText := 'Disconnected';
end; // Tfrm_Main.IdFTPDisconnected

//------------------------------------------------------------------------------

procedure Tfrm_Main.LoadServerList;
var path       : String;
    Stream     : TFileStream;
    BlockCount : Integer;
    Cnt        : integer;
begin
  Path := ExtractFilePath ( Application.ExeName );
  if FileExists( Path + 'Servers.lst' ) then begin
    Stream := TFileStream.Create( Path + 'Servers.lst', fmOpenRead or fmSHareDenyWrite);

    Stream.Position := 0;

    // Uitlezen hoeveel blocks;
    BlockCount := ReadIntFromStream(Stream);
    for Cnt := 0 to BlockCount - 1 do
    begin
      ServerList.Add( TServer.Create );
      with ServerList do begin
        TServer( Items [Count-1] ).HostName := ReadStrFromStream ( Stream );
        TServer( Items [Count-1] ).UserName := ReadStrFromStream ( Stream );
        TServer( Items [Count-1] ).Password := ReadStrFromStream ( Stream );
        TServer( Items [Count-1] ).port     := ReadIntFromStream( Stream );
      end;
    end;
    Stream.Free;
  end;

  RefreshServers;  
end; // Tfrm_Main.LoadServerList

//------------------------------------------------------------------------------

procedure Tfrm_Main.SaveServerList;
var Path : String;
    Stream : TFileStream;
    Cnt : integer;
begin
  Path := ExtractFilePath ( Application.ExeName );
  Stream := TFileStream.Create( Path + 'Servers.lst', fmCreate);

  // Aantal data blocks
  WriteIntToStream(Stream, ServerList.Count );

  // Het schrijven van de data
  for Cnt := 0 to ServerList.count - 1 do
  begin
    WriteStrToStream( Stream, TServer ( ServerList[Cnt]).HostName );
    WriteStrToStream( Stream, TServer ( ServerList[Cnt]).UserName );
    WriteStrToStream( Stream, TServer ( ServerList[Cnt]).Password );
    WriteIntToStream( Stream, TServer ( Serverlist[Cnt]).port );
  end;

  Stream.Free;
end; // Tfrm_Main.SaveServerList

//------------------------------------------------------------------------------

procedure Tfrm_Main.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveServerList;
  ServerList.Free;
end; // Tfrm_Main.FormClose

//------------------------------------------------------------------------------

procedure Tfrm_Main.edtPortKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key < '0') or (Key > '9') then
    Key := #0;
end; // Tfrm_Main.edtPortKeyPress

//------------------------------------------------------------------------------

procedure Tfrm_Main.RefreshServers;
var cnt : integer;
begin
  cmbHost.Clear;
  edtUser.Text     := '';
  edtPassword.Text := '';
  edtPort.Text     := '';

  if Assigned ( ServerList ) then begin
    for Cnt := 0 to ServerList.Count -1 do begin
      cmbHost.AddItem( TServer ( ServerList[Cnt] ).HostName, Nil );
    end;
  end;
end; // Tfrm_Main.RefreshServers

//------------------------------------------------------------------------------

procedure Tfrm_Main.cmbHostChange(Sender: TObject);
begin
  if Assigned ( ServerList ) then begin
    if cmbHost.ItemIndex <> -1 then begin
      edtUser.Text := TServer ( ServerList[cmbHost.ItemIndex] ).UserName;
      edtPassword.Text := TServer ( ServerList[cmbHost.ItemIndex] ).Password;
      edtPort.Text := IntToStr ( TServer ( ServerList[cmbHost.ItemIndex] ).port);
    end;
  end;
end; // Tfrm_Main.cmbHostChange

//------------------------------------------------------------------------------

procedure Tfrm_Main.CreateDir1Click(Sender: TObject);
var path : String;
begin
  frm_Directory := TFrm_Directory.Create ( Application );

  path := ExtractFilePath( Application.ExeName );
  if frm_Directory.ShowModal = mrOk then begin
    MkDir( JvFilesLocal.Directory + frm_directory.edtDirectory.Text );
    JvFilesLocal.Update;
  end;

  frm_Directory.Free;
end; // Tfrm_Main.CreateDir1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.DeleteDir1Click(Sender: TObject);
begin
  if JvFilesLocal.ItemIndex <> -1 then begin
    try
      RmDir( JvFilesLocal.Directory + '\' +
             TrimLeft (JvFilesLocal.Items[JvFilesLocal.ItemIndex])  );
    except
      ShowMessage ( 'Could not delete the selected item' );
    end;

    JvFilesLocal.Update;
  end;
end; // Tfrm_Main.DeleteDir1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.RenameDir1Click(Sender: TObject);
var OldDir, NewDir : String;
    Path : String;
begin
  if JvFilesLocal.ItemIndex <> -1 then begin

    frm_directory := TFrm_Directory.Create ( Application );
    with frm_directory do begin
      edtDirectory.Text := TrimLeft (JvFilesLocal.Items[JvFilesLocal.ItemIndex]);
    end;

    if frm_directory.ShowModal = mrOk then begin
      Path := ExtractFileDir( Application.ExeName ) + '\';
      OldDir := TrimLeft (JvFilesLocal.Items[JvFilesLocal.ItemIndex]);
      NewDir := frm_directory.edtDirectory.Text;
      RenameFile( JvFilesLocal.Directory + OldDir, JvFilesLocal.Directory + NewDir );
      JvFilesLocal.Update;
    end;

    frm_directory.Free;
  end;
end; // Tfrm_Main.RenameDir1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.DeleteFile1Click(Sender: TObject);
begin
  if JvFilesLocal.ItemIndex <> -1 then begin
    try
      DeleteFile( JvFilesLocal.Directory + '\' +
                  TrimLeft (JvFilesLocal.Items[JvFilesLocal.ItemIndex]));
    except
      ShowMessage ( 'Could not delete the selected item' );
    end;

    JvFilesLocal.Update;
  end;
end; // Tfrm_Main.DeleteFile1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.GetFtpItems;
var cnt : integer;
begin
  JvFilesRemote.Items.Clear;
  lblRemotePath.Caption := IdFTP.RetrieveCurrentDir;

  IdFTP.List(nil);

  JvFilesRemote.Items.Add ('..');

  for cnt := 0 to IdFTP.DirectoryListing.Count -1 do begin
    if (idFTP.DirectoryListing.Items[Cnt].ItemType = ditDirectory) then
      JvFilesRemote.Items.Add ( Trim (idFTP.DirectoryListing.Items[Cnt].FileName) )
  end;

  for cnt := 0 to IdFTP.DirectoryListing.Count -1 do begin
    if Not (idFTP.DirectoryListing.Items[Cnt].ItemType = ditDirectory) then
      JvFilesRemote.Items.Add ( idFTP.DirectoryListing.Items[Cnt].FileName);
  end;

end; // Tfrm_Main.GetFtpItems

//------------------------------------------------------------------------------

procedure Tfrm_Main.JvFilesRemoteDblClick(Sender: TObject);
var SelectedItem : string;
begin
  if Not HasMultipleSelections( Sender ) then begin
    SelectedItem := TrimLeft ( JvFilesRemote.Items[GetFirstSelectedItem(Sender)] );
    try
      IdFTP.ChangeDir( SelectedItem );
    except
    end;

    GetFtpItems;
  end;
end; // Tfrm_Main.JvFilesRemoteDblClick

//------------------------------------------------------------------------------

procedure Tfrm_Main.CreateDir2Click(Sender: TObject);
begin
  frm_Directory := TFrm_Directory.Create ( Application );

  if frm_Directory.ShowModal = mrOk then begin
    IdFTP.MakeDir( frm_directory.edtDirectory.Text );
  end;

  frm_Directory.Free;

  GetFtpItems;
end; // Tfrm_Main.CreateDir2Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.DeleteDir2Click(Sender: TObject);
begin
  if JvFilesRemote.ItemIndex <> -1 then begin
    try
      IdFTP.RemoveDir( TrimLeft (JvFilesRemote.Items[JvFilesRemote.ItemIndex]) );
    except
      ShowMessage ( 'Could not delete the selected item' );
    end;

    GetFtpItems;
  end;

end; // Tfrm_Main.DeleteDir2Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.DeleteFile2Click(Sender: TObject);
begin
  if JvFilesRemote.ItemIndex <> -1 then begin
    try
      IdFTP.Delete(TrimLeft (JvFilesRemote.Items[JvFilesRemote.ItemIndex]));
    except
      ShowMessage ( 'Could not delete the selected item' );
    end;

    GetFtpItems;
  end;
end;

//------------------------------------------------------------------------------

procedure Tfrm_Main.Send1Click(Sender: TObject);
begin
  if JvFilesLocal.ItemIndex <> -1 then begin
    try
      IdFTP.Put( JvFilesLocal.Directory + '\' + TrimLeft (JvFilesLocal.Items[JvFilesLocal.ItemIndex]),
                 TrimLeft (JvFilesLocal.Items[JvFilesLocal.ItemIndex]));
    except
      ShowMessage ( 'Could not upload the selected item' );
    end;

    GetFtpItems;
  end;
end; // Tfrm_Main.Send1Click

//------------------------------------------------------------------------------

procedure Tfrm_Main.Send2Click(Sender: TObject);
begin
  if JvFilesRemote.ItemIndex <> -1 then begin
    try
      IdFTP.Get( TrimLeft (JvFilesRemote.Items[JvFilesRemote.ItemIndex]),
                 JvFilesLocal.Directory + '\' + TrimLeft (JvFilesRemote.Items[JvFilesRemote.ItemIndex]));
    except
      ShowMessage ( 'Could not recieve the selected item' );
    end;

    JvFilesLocal.Update;
  end;
end; //Tfrm_Main.Send2Click

//------------------------------------------------------------------------------

end.



