unit ufrm_Servers;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Contnrs, uServerInfo;

type
  Tfrm_Servers = class(TForm)
    Bevel1: TBevel;
    lblServers: TLabel;
    ListBox1: TListBox;
    btnAdd: TButton;
    btnEdit: TButton;
    btnDelete: TButton;
    btnClose: TButton;
    Bevel2: TBevel;
    lblHost: TLabel;
    edtHost: TEdit;
    lblUser: TLabel;
    edtUser: TEdit;
    lblPassword: TLabel;
    edtPassword: TEdit;
    lblPort: TLabel;
    edtPort: TEdit;
    Bevel3: TBevel;
    btnCancel: TButton;
    btnOk: TButton;
    procedure btnAddClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure edtPortKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    SelectedItem : Integer;

    procedure EnableAddEditDelete;
    procedure DisableAddEditDelete;

    procedure EnableOkCancel;
    procedure DisableOkCancel;

    procedure SetServerProperties ( Index : integer);
    procedure ClearEdits;

    procedure EnableEdits;
    procedure DisableEdits;
  public
    { Public declarations }
    Servers : TObjectList;
    procedure FillServerList;
  end;

var
  frm_Servers: Tfrm_Servers;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------

procedure Tfrm_Servers.FillServerList;
var cnt : integer;
begin
  ListBox1.Items.Clear;
  if Assigned ( Servers ) then begin
    for cnt := 0 to Servers.Count -1 do begin
      ListBox1.Items.Add( TServer (Servers.Items[cnt]).HostName );
    end;
  end;
end; // Tfrm_Servers.FillServerList

//------------------------------------------------------------------------------

procedure Tfrm_Servers.btnAddClick(Sender: TObject);
begin
  Servers.Add( TServer.Create );

  with Servers do begin
    TServer( Items [Count-1] ).HostName := 'Server Name';
    TServer( Items [Count-1] ).UserName := 'User Name';
    TServer( Items [Count-1] ).Password := 'Password';
    TServer( Items [Count-1] ).port     := 21;
  end;

  FillServerList;
end; // Tfrm_Servers.btnAddClick

//------------------------------------------------------------------------------

procedure Tfrm_Servers.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex <> -1 then begin
    SetServerProperties (ListBox1.ItemIndex);
  end;
end; // Tfrm_Servers.ListBox1Click

//------------------------------------------------------------------------------

procedure Tfrm_Servers.SetServerProperties ( Index : integer);
begin
  if Assigned ( Servers ) then begin
    edtHost.Text     := TServer ( Servers[Index] ).HostName;
    edtUser.Text     := TServer ( Servers[Index] ).UserName;
    edtPassword.Text := TServer ( Servers[Index] ).Password;
    edtPort.Text     := IntToStr ( TServer ( Servers[Index] ).port );
  end;
end; // Tfrm_Servers.SetServerProperties

//------------------------------------------------------------------------------

procedure Tfrm_Servers.btnDeleteClick(Sender: TObject);
begin
  if ListBox1.ItemIndex <> -1 then begin
    Servers.Delete( ListBox1.ItemIndex );
    ClearEdits;
  end;
  FillServerList;
end; // Tfrm_Servers.btnDeleteClick

//------------------------------------------------------------------------------

procedure Tfrm_Servers.ClearEdits;
begin
  edtHost.Text     := '';
  edtUser.Text     := '';
  edtPassword.Text := '';
  edtPort.Text     := '';
end; // Tfrm_Servers.ClearEdits

//------------------------------------------------------------------------------

procedure Tfrm_Servers.DisableAddEditDelete;
begin
  btnAdd.Enabled    := False;
  btnEdit.Enabled   := False;
  btnDelete.Enabled := False;
end; // Tfrm_Servers.DisableAddEditDelete

//------------------------------------------------------------------------------

procedure Tfrm_Servers.DisableOkCancel;
begin
  btnOk.Enabled     := False;
  btnCancel.Enabled := False;
end; // Tfrm_Servers.DisableOkCance

//------------------------------------------------------------------------------

procedure Tfrm_Servers.EnableAddEditDelete;
begin
  btnAdd.Enabled    := True;
  btnEdit.Enabled   := True;
  btnDelete.Enabled := True;
end; // Tfrm_Servers.EnableAddEditDelete

//------------------------------------------------------------------------------

procedure Tfrm_Servers.EnableOkCancel;
begin
  btnOk.Enabled     := True;
  btnCancel.Enabled := True;
end; // Tfrm_Servers.EnableOkCancel

//------------------------------------------------------------------------------

procedure Tfrm_Servers.btnEditClick(Sender: TObject);
begin
  if ListBox1.ItemIndex <> -1 then begin
    DisableAddEditDelete;
    EnableOkCancel;
    EnableEdits;
    SelectedItem := ListBox1.ItemIndex;
  end;
end; // Tfrm_Servers.btnEditClick

//------------------------------------------------------------------------------

procedure Tfrm_Servers.btnOkClick(Sender: TObject);
begin
  if Assigned ( Servers ) then begin
    with Servers do begin
      TServer ( Items [SelectedItem] ).HostName := edtHost.Text;
      TServer ( Items [SelectedItem] ).UserName := edtUser.Text;
      TServer ( Items [SelectedItem] ).Password := edtPassword.Text;
      TServer ( Items [SelectedItem] ).port     := StrToInt ( edtPort.Text );
    end;
  end;
  btnCancel.Click;
end; // Tfrm_Servers.btnOkClick

//------------------------------------------------------------------------------

procedure Tfrm_Servers.btnCancelClick(Sender: TObject);
begin
  EnableAddEditDelete;
  DisableOkCancel;
  DisableEdits;
  ClearEdits;
  FillServerList;
end; // Tfrm_Servers.btnCancelClick

//------------------------------------------------------------------------------

procedure Tfrm_Servers.edtPortKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key < '0') or (Key > '9') then
    Key := #0;
end; // Tfrm_Servers.edtPortKeyPress

//------------------------------------------------------------------------------

procedure Tfrm_Servers.DisableEdits;
begin
  edtHost.Enabled     := False;
  edtUser.Enabled     := False;
  edtPassword.Enabled := False;
  edtPort.Enabled     := False;
  lblHost.Enabled     := False;
  lblUser.Enabled     := False;
  lblPassword.Enabled := False;
  lblPort.Enabled     := False;
end; // Tfrm_Servers.DisableEdits

//------------------------------------------------------------------------------

procedure Tfrm_Servers.EnableEdits;
begin
  edtHost.Enabled     := True;
  edtUser.Enabled     := True;
  edtPassword.Enabled := True;
  edtPort.Enabled     := True;
  lblHost.Enabled     := True;
  lblUser.Enabled     := True;
  lblPassword.Enabled := True;
  lblPort.Enabled     := True;
end; // Tfrm_Servers.EnableEdits

//------------------------------------------------------------------------------

end.
